EmoteThief = {
	name = "EmoteThief",
	version = 1,
	variableVersion = 1
}

EmoteThief.Settings = {
	saved_personality = nil
}

-- add new emotes here, in format {command_name, collectible, emote}
local emote_list = {
	{"bluelute", 8080, 5}, -- minstrel lute
	{"tambourine", 8080, 7}, -- minstrel drum
	{"flute2", 8080, 6}, -- minstrel flute
	{"harp", 10913, 5}, -- passion's muse lute
	{"balance", 10913, 91}, -- passion's muse stretch
	{"plantlight", 10913, 98}, -- passion's muse ritual
	{"fireorb", 774, 151}, -- deadlands firewalker doom
	{"jestercheer", 773, 25}, -- jester cheer
	{"breathefire", 773, 178}, -- jester spit
	{"kneelwithbook", 775, 102}, -- scholar kneel
	{"telescope", 6927, 110}, -- swashbuckler search
	{"read2books", 1234, 10}, -- telvanni magister read
	{"jugglelight", 1234, 194}, -- telvanni magister juggleflame
	{"playwithlight", 1234, 98}, -- telvanni magister ritual
	{"crouchwithtorch", 5884, 101}, -- treasure hunter crouch
	{"readwithtorch", 5884, 10}, -- treasure hunter read
	{"summonskull", 4725, 151}, -- worm wizard doom
	{"summonskeleton", 4725, 98} -- worm wizard ritual
}

function EmoteThief.CheckEmoteEnd()
	if IsPlayerMoving() or SCENE_MANAGER:GetScene("stats").state == "shown"  then
		if EmoteThief.Settings.saved_personality ~= 0 then
			UseCollectible(EmoteThief.Settings.saved_personality)
		else
			UseCollectible(GetActiveCollectibleByType(COLLECTIBLE_CATEGORY_TYPE_PERSONALITY))
		end
		EmoteThief.Settings.saved_personality = nil
		EVENT_MANAGER:UnregisterForUpdate("EmoteThief_CheckEmoteEnd")
	end
end

function EmoteThief.PlayEmote(emote)
	EVENT_MANAGER:UnregisterForEvent("EmoteThief_PlayEmote", EVENT_PERSONALITY_CHANGED)
	PlayEmoteByIndex(emote)
	EVENT_MANAGER:RegisterForUpdate("EmoteThief_CheckEmoteEnd", 250, EmoteThief.CheckEmoteEnd)
end


function EmoteThief.OnPlayerActivated()
	if EmoteThief.Settings.saved_personality == nil then return end
	UseCollectible(EmoteThief.Settings.saved_personality)
	EmoteThief.Settings.saved_personality = nil
end

function EmoteThief.Initialize()
	for _, value in ipairs(emote_list) do
		local command_name = value[1]
		local collectible = value[2]
		local emote = value[3]

		if (IsCollectibleOwnedByDefId(collectible)) then
			SLASH_COMMANDS["/" .. command_name] = function()
				if collectible == GetActiveCollectibleByType(COLLECTIBLE_CATEGORY_TYPE_PERSONALITY) then
					PlayEmoteByIndex(emote)
					return
				end
				if (EmoteThief.Settings.saved_personality == nil) then 
					EmoteThief.Settings.saved_personality = GetActiveCollectibleByType(COLLECTIBLE_CATEGORY_TYPE_PERSONALITY)
				end
				EVENT_MANAGER:RegisterForEvent("EmoteThief_PlayEmote", EVENT_PERSONALITY_CHANGED, function() EmoteThief.PlayEmote(emote) end)
				UseCollectible(collectible)
			end
		end
	end
end

function EmoteThief.OnAddOnLoaded(event, addonName)
	if addonName ~= EmoteThief.name then return end
	EmoteThief:Initialize()
	EmoteThief.Settings = ZO_SavedVars:New('EmoteThiefSettings', 1, nil, EmoteThief.Settings)
	EVENT_MANAGER:UnregisterForEvent(EmoteThief.name, EVENT_ADD_ON_LOADED)
	EVENT_MANAGER:RegisterForEvent(EmoteThief.name, EVENT_PLAYER_ACTIVATED, EmoteThief.OnPlayerActivated)
end

EVENT_MANAGER:RegisterForEvent(EmoteThief.name, EVENT_ADD_ON_LOADED, EmoteThief.OnAddOnLoaded)


